package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description : 模块表单枚举类
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 21:08
 * @Modify:
 **/
public class BlockFormEnumUtil {

    /**
     * 原数据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum FORM_TABLE_TYPE {
        TABLE(1, "table", "表"),
        VIEW(2, "view", "视图");

        private int value;
        private String code;
        private String description;

        private FORM_TABLE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code.toLowerCase())) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static FORM_TABLE_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 原数据状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum FORM_TABLE_STATUS {
        SYNCHRONOUS_UNDONE(1, "未完成", "未同步"),
        SYNCHRONOUS_COMPLETE(2, "已完成", "已同步");

        private int value;
        private String code;
        private String description;

        private FORM_TABLE_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code.toLowerCase())) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static FORM_TABLE_STATUS valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 行信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TABLE_ROW_PICK {
        SINGLE(1, "single", "单选"),
        MULTI(2, "multi", "多选");

        private int value;
        private String code;
        private String description;

        private TABLE_ROW_PICK(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static TABLE_ROW_PICK valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 显示行号信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TABLE_ROW_NUMBER {
        SHOW(1, "show", "显示"),
        HIDE(2, "hide", "隐藏");

        private int value;
        private String code;
        private String description;

        private TABLE_ROW_NUMBER(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static TABLE_ROW_NUMBER valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素新增信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ELEMENT_ADD_STATUS {
        ON(1, "ON", "开启"),
        OFF(2, "OFF", "关闭");

        private int value;
        private String code;
        private String description;

        private ELEMENT_ADD_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static ELEMENT_ADD_STATUS valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素编辑信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ELEMENT_EDIT_STATUS {
        ON(1, "ON", "开启"),
        OFF(2, "OFF", "关闭");

        private int value;
        private String code;
        private String description;

        private ELEMENT_EDIT_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static ELEMENT_EDIT_STATUS valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ELEMENT_TYPE {
        GRID(1, "TABLE", "表格"),
        TREE(2, "TREE", "树");

        private int value;
        private String code;
        private String description;

        private ELEMENT_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static ELEMENT_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素删除信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ELEMENT_DEL_STATUS {
        ON(1, "ON", "开启"),
        OFF(2, "OFF", "关闭");

        private int value;
        private String code;
        private String description;

        private ELEMENT_DEL_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static ELEMENT_DEL_STATUS valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素查询信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ELEMENT_FIND_STATUS {
        ON(1, "ON", "开启"),
        OFF(2, "OFF", "关闭");

        private int value;
        private String code;
        private String description;

        private ELEMENT_FIND_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static ELEMENT_FIND_STATUS valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 元素控件类型信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PROPERTY_CONTROL_TYPE {
        RADIO(100, "RADIO", "单选"),
        CHECKBOX(110, "CHECKBOX", "复选"),
        TEXT(200, "TEXT", "文本"),
        NUMBER(210, "NUMBER", "数字"),
        PASSWORD(230, "PASSWORD", "密码"),
        DATE(300, "DATE", "日期(yyyy-MM-dd)"),
        DATE_TIME(310, "DATE_TIME", "时间(yyyy-MM-dd hh:mm:ss)"),
        DICTIONARY(800, "DICT_SELECT", "字典"),
        CASCADE(900, "CASCADE", "级联");
        //FILE(400, "file", "文件"),
        //IMAGE(410, "image", "image"),
        //OFF(500, "color", "颜色"),

        private int value;
        private String code;
        private String description;

        private PROPERTY_CONTROL_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static PROPERTY_CONTROL_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 属性字段排序规则
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PROPERTY_ORDER_BY {
        ASC(1, "ASC", "升序"),
        DESC(2, "DESC", "降序");

        private int value;
        private String name;
        private String description;

        PROPERTY_ORDER_BY(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getName();
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 虚拟类型信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PROPERTY_VIRTUAL_OPERATE_TYPE {
        STRING_SPLICE(10, "SPLICE", "字符串拼接"),
        NUM_ADD(20, "ADD", "加法计算"),
        NUM_LESS(30, "MIN", "减法计算"),
        NUM_MAKE(40, "MUL", "乘法计算"),
        NUM_DIVISION(50, "DIVISION", "除法计算");

        private int value;
        private String code;
        private String description;

        private PROPERTY_VIRTUAL_OPERATE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static PROPERTY_VIRTUAL_OPERATE_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 属性类型信息(属性转换器)
     * <per>
     * <br/>    Form 核心转换器
     * <br/>    数据库字段类型转换Java 属性类型
     * <br/>    Java 属性 转换为控件类型
     * </per>
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PROPERTY_TYPE {
        STRING(10, "String", "字符串", "java.lang.String", String.class,PROPERTY_CONTROL_TYPE.TEXT),
        CHAR(11, "Character", "单字符", "java.lang.Character", Character.class,PROPERTY_CONTROL_TYPE.TEXT),
        INTEGER(20, "Integer", "短整型", "java.lang.Integer", Integer.class,PROPERTY_CONTROL_TYPE.NUMBER),
        LONG(21, "Long", "长整型", "java.lang.Long", Long.class,PROPERTY_CONTROL_TYPE.NUMBER),
        DOUBLE(30, "Double", "大浮点型", "java.lang.Double", Double.class,PROPERTY_CONTROL_TYPE.NUMBER),
        FLOAT(31, "Float", "小浮点型", "java.lang.Float", Float.class,PROPERTY_CONTROL_TYPE.NUMBER),
        BOOLEAN(40, "Boolean", "布尔值", "java.lang.Boolean", Boolean.class,PROPERTY_CONTROL_TYPE.RADIO),
        BYTE(50, "Byte", "字节", "java.lang.Byte", Byte.class,PROPERTY_CONTROL_TYPE.TEXT),
        DATE(60, "Date", "日期", "java.lang.String", String.class,PROPERTY_CONTROL_TYPE.DATE_TIME);

        /**
         * 属性类型值
         */
        private int value;
        /**
         * 属性类型代码
         */
        private String code;
        /**
         * 属性类型描述
         */
        private String description;
        /**
         * 属性类型ClassPath
         */
        private String classPath;
        /**
         * 属性类型 Class
         */
        private Class clzFullName;
        /**
         *  属性类型 对应的 控件类型
         */
        private PROPERTY_CONTROL_TYPE controlType;

        private PROPERTY_TYPE(int value, String code, String description,String classPath,Class clzFullName,PROPERTY_CONTROL_TYPE controlType) {
            this.value = value;
            this.code = code;
            this.description = description;
            this.classPath = classPath;
            this.clzFullName = clzFullName;
            this.controlType = controlType;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static Class valueOfClzFullName(int val) {
            Class tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].clzFullName;
                }
            }
            return tmp;
        }

        public static PROPERTY_CONTROL_TYPE valueOfControlType(int val) {
            PROPERTY_CONTROL_TYPE tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].controlType;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static int codeOfClzFullName(Class clzFullName) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].clzFullName.equals(clzFullName)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static int codeOfClassPath(String classPath) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].classPath.equals(classPath)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static PROPERTY_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static PROPERTY_TYPE indexOf(String val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (val.indexOf(values()[i].value) >= 0) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 执行类型信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum EXECUTION_TYPE {
        SQL(10, "SQL", "SQL脚本"),
        CLASS_METHOD(20, "ClassMethod", "类方法"),
        SCRIPT(30, "Script", "脚本"),;

        private int value;
        private String code;
        private String description;

        private EXECUTION_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static EXECUTION_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 拦截器类型信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum INTERCEPT_TYPE {
        ELEMENT_ADD(10, "ELEMENT_ADD", "元素新增"),
        ELEMENT_EDIT(20, "ELEMENT_EDIT", "元素修改"),
        ELEMENT_DEL(30, "ELEMENT_DEL", "元素删除"),
        ELEMENT_FIND(40, "ELEMENT_FIND", "元素查询"),
        CUSTOM_BUTTON(50, "CUSTOM_BUTTON", "自定义按钮");

        private int value;
        private String code;
        private String description;

        private INTERCEPT_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static INTERCEPT_TYPE valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 拦截器位置信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum INTERCEPT_POSITION {
        BEFORE_EXECUTION(10, "BEFORE", "执行前"),
        AFTER_SUCCESS(20, "AFTER_SUCCESS", "执行成功后"),
        AFTER_FAIL(30, "AFTER_FAIL", "执行失败后");

        private int value;
        private String code;
        private String description;

        private INTERCEPT_POSITION(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static INTERCEPT_POSITION valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 拦截器业务结果处理信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum INTERCEPT_PROCESS_RESULT {
        CONTINUE_AFTER_SUCCESS(10, "CONTINUE_AFTER_SUCCESS", "成功后继续"),
        STOP_AFTER_SUCCESS(20, "STOP_AFTER_SUCCESS", "成功后停止"),
        CONTINUE_AFTER_FAIL(30, "CONTINUE_AFTER_FAIL", "失败后继续"),
        CONTINUE_AFTER_STOP(40, "CONTINUE_AFTER_STOP", "失败后停止");

        private int value;
        private String code;
        private String description;

        private INTERCEPT_PROCESS_RESULT(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static INTERCEPT_PROCESS_RESULT valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 表单功能明细 触发信息
     * <per>
     * onclick      script     元素上发生鼠标点击时触发。
     * ondblclick   script     元素上发生鼠标双击时触发。
     * ondrag       script     元素被拖动时运行的脚本。
     * ondragend    script     在拖动操作末端运行的脚本。
     * ondragenter  script     当元素元素已被拖动到有效拖放区域时运行的脚本。
     * ondragleave  script     当元素离开有效拖放目标时运行的脚本。
     * ondragover   script     当元素在有效拖放目标上正在被拖动时运行的脚本。
     * ondragstart  script     在拖动操作开端运行的脚本。
     * ondrop       script     当被拖元素正在被拖放时运行的脚本。
     * onmousedown  script     当元素上按下鼠标按钮时触发。
     * onmousemove  script     当鼠标指针移动到元素上时触发。
     * onmouseout   script     当鼠标指针移出元素时触发。
     * onmouseover  script     当鼠标指针移动到元素上时触发。
     * onmouseup    script     当在元素上释放鼠标按钮时触发。
     * onmousewheel script     当鼠标滚轮正在被滚动时运行的脚本。
     * onscroll     script     当元素滚动条被滚动时运行的脚本。
     * </per>
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TRIGGER_EVENT {
        CLICK(10, "CLICK", "单击"),
        DB_LCLICK(20, "DB_LCLICK", "双击"),
        MOUSE_OUT(30, "MOUSE_OUT", "鼠标指针移出"),
        MOUSE_OVER(40, "MOUSE_OVER", "鼠标指针移动入");

        private int value;
        private String code;
        private String description;

        private TRIGGER_EVENT(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].code;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static TRIGGER_EVENT valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 表单功能明细 触发效果信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum BUTTON_TRIGGER_EFFECT {
        DIALOG(10, "DIALOG", "弹出窗口"),
        NEW_WINDOW(20, "NEW_WINDOW", "新开窗口"),
        SQL(30, "SQL", "执行SQL"),
        CLASS_METHOD(40, "CLASS_METHOD", "执行类方法");

        private int value;
        private String name;
        private String description;

        BUTTON_TRIGGER_EFFECT(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static BUTTON_TRIGGER_EFFECT valueOf(int val) {
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * SQL 连接关系信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SQL_REF_TYPE {
        GT(1, ">", "大于"),
        GT_EQUAL(2, ">=", "大于等于"),
        LT(3, "<", "小于等于"),
        LT_EQUAL(4, "<=", "小于等于"),
        EQUAL(5, "=", "等于"),
        EQUAL_NOT(6, "<>", "不等于");

        private int value;
        private String name;
        private String description;

        SQL_REF_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static SQL_REF_TYPE valueOf(int val) {
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 菜单类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MENU_TYPE {
        FORM_METHOD(1, "FORM_METHOD", "表单功能"),
        OUTER_CHAIN(2, "OUTER_CHAIN", "外链");

        private int value;
        private String name;
        private String description;

        MENU_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static MENU_TYPE valueOf(int val) {
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    return values()[i];
                }
            }
            return null;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

}
