package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description : sweb枚举类
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-02 20:21
 * @Modify:
 **/
public class SwebEnumUtil {

    /**
     * 单据主表状态(ASN,PO,MOVE,QC)
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_MASTER_STATUS {
        CREATE(10, "新建"),
        RECEIPT(20, "已发布"),
        RECEIPT_FINISH(30, "已确认"),
        CLOSED(40, "已打印"),
        CANCELLED(50, "已发货");

        private int value;
        private String description;

        ORDER_MASTER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 订单明细状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_DETAILS_STATUS {
        CREATE(10, "新建"),
        RECEIPT(20, "已发布"),
        RECEIPT_FINISH(30, "已确认"),
        CLOSED(40, "已打印"),
        CANCELLED(50, "已发货");

        private int value;
        private String description;

        ORDER_DETAILS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

}
