package cn.estsh.i3plus.pojo.form.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 表单拦截器
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2019-03-21 16:25
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BF_INTERCEPT")
@Api(value="拦截器主体")
public class BfIntercept extends BaseBean {

    @Column(name="INTERCEPT_NAME")
    @ApiParam(value ="拦截器名称")
    private String interceptName;

    @Column(name="EXECUTE_MODE")
    @ApiParam(value ="执行方式")
    @JsonSerialize(using = ToStringSerializer.class)
    private Integer executeMode;

    @Column(name="EXECUTE_CONTENT")
    @ApiParam(value ="执行内容")
    @JsonSerialize(using = ToStringSerializer.class)
    private Integer executeContent;
}
