package cn.estsh.i3plus.pojo.model.form;

import cn.estsh.i3plus.pojo.form.bean.*;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.util.List;

/**
 * @Description : 元素Model
 * @Reference : 元素整体封装
 * @Author : Adair Peng
 * @CreateDate : 2019-03-21 13:14
 * @Modify:
 **/
@Data
public class ElementModel{

    @ApiParam(value = "元素基础信息")
    private BfElement element;

    @ApiParam(value = "元素Tree信息")
    private BfElementTree elementTree;

    @ApiParam(value = "元素Grid信息")
    private BfElementGrid elementGrid;

    @ApiParam(value = "元素基础属性信息")
    private List<BfElementProperty> propertyList;

    @ApiParam(value = "元素基础虚拟属性信息")
    private List<BfElementPropertyVirtual> virtualList;

    @ApiParam(value = "数据对象信息")
    private BfDataObject dataObject;

    @ApiParam(value = "元素类型")
    private Integer elementType;

}
