package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 系统消息
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.689
 * @Modify      :
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_MESSAGE")
@Api(value="系统消息",description = "系统消息")
public class SysMessage extends BaseBean {

    @Column(name="MESSAGE_TITLE")
    @ApiParam(value ="消息标题" , access ="消息标题")
    private String messageTitle;

    @Column(name="MESSAGE_TYPE")
    @ApiParam(value ="消息类型(枚举：ImppEnumUtil.MESSAGE_TYPE)" , example ="-1")
    private Integer messageType;

    @Column(name="MESSAGE_TYPE_CONTENT")
    @ApiParam(value ="消息内容类型(枚举：ImppEnumUtil.MESSAGE_TYPE_CONTENT)" , example ="-1")
    private Integer messageContentType;

    @Column(name="MESSAGE_CONTENT",columnDefinition = "TEXT")
    @ApiParam(value ="消息内容" , access ="消息内容")
    private String messageContent;

    @Column(name="MESSAGE_SENDER_ID")
    @ApiParam(value ="发送者id" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long messageSenderId;

    @Column(name="MESSAGE_SENDER_NAME_RDD")
    @ApiParam(value ="发送者名称" )
    private String messageSenderNameRdd;

    @Column(name="MESSAGE_RECEIVER_TYPE")
    @ApiParam(value ="收件人类型(枚举：ImppEnumUtil.MESSAGE_TYPE)" , example ="-1")
    private Integer messageReceiverType;

    @Column(name="MESSAGE_RECEIVERS_ID")
    @ApiParam(value ="收件者id" )
    private String messageReceiversId;

    @Column(name="MESSAGE_RECEIVERS_NAME_RDD")
    @ApiParam(value ="接受者名称集合" )
    private String messageReceiversNameRdd;

    @Column(name="MESSAGE_SEND_TIME")
    @ApiParam(value ="发送时间" )
    private String messageSendTime;

    @Column(name="IS_URGENT")
    @ApiParam(value ="是否紧急")
    private Integer isUrgent;

    @Column(name="IS_SYSTEM")
    @ApiParam(value ="是否系统邮件")
    private Integer isSystem;
}
