package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * @Description : 自定义报表布局
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_LAYOUT_ROW")
@Api(value="自定义报表布局-行",description = "一个布局包含多行，一行包含多列")
public class BrLayoutRow extends BaseBean {

    @Column(name="LAYOUT_ID")
    @ApiParam(value ="布局主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutId;

    @Column(name="ROW_WIDTH")
    @ApiParam(value ="行宽")
    private Integer rowWidth;

    @Column(name="ROW_HEIGHT")
    @ApiParam(value ="行高")
    private Integer rowHeight;

    @Column(name="ROW_SORT")
    @ApiParam(value ="排序")
    private Integer rowSort;

    @Column(name="ROW_STYLE",columnDefinition = "TEXT")
    @ApiParam(value ="行样式")
    private String rowStyle;

    @Column(name="ROW_COL_NUM")
    @ApiParam(value ="行所关联列数")
    private Integer rowColNum;

    @Column(name="ROW_HTML",columnDefinition = "TEXT")
    @ApiParam(value ="行html")
    private String rowHtml;

    @Transient
    @ApiParam(value ="行所包含的列")
    private List<BrLayoutColumn> brLayoutColumns;
}
