package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-17 11:17
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_REF_ROLE_MENU")
@Api(value="关系-角色目录",description = "关系-角色目录")
public class BrRefRoleMenu extends BaseBean {

    @Column(name="MENU_ID")
    @ApiParam(value ="菜单ID" ,example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long menuId;

    @Column(name="MENU_NAME_RDD")
    @ApiParam(value ="菜单名称" , access ="菜单名称")
    private String menuNameRdd;

    @Column(name="MENU_TYPE_RDD")
    @ApiParam(value ="菜单类型")
    private Integer menuTypeRdd;

    @Column(name="ROLE_ID")
    @ApiParam(value ="角色ID" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long roleId;

    @Column(name="ROLE_NAME_Rdd")
    @ApiParam(value ="角色名称" , access ="角色名称")
    private String roleNameRdd;

}
