package cn.estsh.i3plus.pojo.sweb.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 11:21
 * @Modify:
 **/
@Data
@Table(name = "SWEB_PACKAGE")
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("物理包装")
public class SwebPackage extends BaseBean {

    @Column(name="PACKAGE_NO")
    @ApiParam("包装编号")
    public String packageNo;

    @Column(name="PACKAGE_TYPE_ID")
    @ApiParam(value = "包装类型", example = "1")
    public Integer packTypeId;

    @Column(name="PARENT_PACKAGE_NO")
    @ApiParam("上级包装编号")
    public String parentPackageNo;

    @ColumnDefault("0")
    @Column(name="PACKAGE_QTY")
    @ApiParam(value = "包装件数", example = "1")
    public Integer packageQty;
}
