package cn.estsh.i3plus.pojo.sweb.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 11:21
 * @Modify:
 **/
@Data
@Table(name = "SWEB_PROCUREMENT_PLAN_ORDER")
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("开口合同主表")
public class SwebProcurementPlanOrder extends BaseBean {

    @ApiParam("合同号")
    @Column(name = "ORDER_NO")
    private String orderNo;

    @ApiParam(value = "订单类型", example = "1")
    @Column(name = "ORDER_TYPE")
    private Integer orderType;

    @ApiParam(value = "订单状态", example = "10")
    @Column(name = "ORDER_STATUS")
    private Integer orderStatus;

    @ApiParam("供应商代码")
    @Column(name = "VENDOR_CODE")
    private String vendorCode;
}
