package cn.estsh.i3plus.pojo.sweb.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 11:21
 * @Modify:
 **/
@Data
@Table(name = "SWEB_PROCUREMENT_PLAN_ORDER_DETAILS")
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("开口合同明细表")
public class SwebProcurementPlanOrderDetails extends BaseBean {

    @ApiParam("单据号")
    @Column(name = "ORDER_NO")
    private String orderNo;

    @ApiParam(value = "零件号")
    @Column(name = "PART_NO")
    private String partNo;

    @ApiParam(value = "零件名称")
    @Column(name = "PART_NAME")
    private String partName;

    @ApiParam(value = "单位")
    @Column(name = "UNIT")
    private String unit;

    @ColumnDefault("0")
    @ApiParam("标准包装")
    @Column(name = "SNP_QTY")
    private Double snpQty;

    @ApiParam(value = "行项目状态", example = "1")
    @Column(name = "ITEM_STATUS")
    private Integer itemStatus;
}
