package cn.estsh.i3plus.pojo.sweb.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 11:21
 * @Modify:
 **/
@Data
@Table(name = "SWEB_PURCHASE_CHANGE_LOG")
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("订单修改日志记录表")
public class SwebPurchaseChangeLog extends BaseBean {

    @Column(name = "ORDER_NO")
    @ApiParam("单据明细编号")
    public String orderNo;

    @ApiParam(value = "零件号")
    @Column(name = "PART_NO")
    private String partNo;

    @ApiParam(value = "订单当前状态")
    @Column(name = "ITEM_STATUS")
    private Integer itemStatus;

    @Column(name = "QTY")
    @ApiParam("零件数量")
    @ColumnDefault("0")
    public Double qty;

    @Column(name = "REMARK")
    @ApiParam("备注")
    private String remark;
}
