package cn.estsh.i3plus.pojo.sweb.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 11:21
 * @Modify:
 **/
@Data
@Table(name = "SWEB_PURCHASE_ORDER")
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("采购订单表-主表")
public class SwebPurchaseOrder extends BaseBean {

    @Column(name = "ORDER_NO")
    @ApiParam("单据号")
    public String orderNo;

    @ApiParam("供应商编号")
    @Column(name = "VENDOR_CODE")
    private String vendorCode;

    @ApiParam("供应商名称")
    @Column(name = "VENDOR_NAME")
    private String vendorName;

    @ApiParam("计划员代码")
    @Column(name = "PLANNER_CODE")
    private String plannerCode;

    @ApiParam(value = "订单类型", example = "1")
    @Column(name = "ORDER_TYPE")
    public Integer orderType;

    @ApiParam(value = "订单状态", example = "1")
    @Column(name = "ORDER_STATUS")
    public Integer orderStatus;

    @Column(name = "PARENT_PACKAGE_NO")
    @ApiParam("上级包装编号")
    public String parentPackageNo;

    @Column(name = "DOCK")
    @ApiParam("道口")
    public String dock;

    @Column(name = "ERP_WAREHOUSE")
    @ApiParam(value = "库存地")
    public String erpWarehouse;

    @Column(name = "PO_STATUS")
    @ApiParam(value = "PO状态", example = "1")
    public Integer poStatus;

    @Column(name = "SHIP_TIME")
    @ApiParam(value = "发运时间")
    public String shipTime;

    @Column(name = "PUBLISH_TIME")
    @ApiParam(value = "发布时间")
    public String publishTime;

    @Column(name = "DELIVERY_TIME")
    @ApiParam(value = "交货时间")
    public String deliveryTime;

    @Column(name = "REC_TIME")
    @ApiParam(value = "收货时间")
    public String recTime;

    @Column(name = "IS_SYN")
    @ApiParam(value = "是否收货", example = "2")
    public Integer isSyn;

    @Column(name = "ORDER_TIME")
    @ApiParam(value = "订单时间")
    public String orderTime;

    @Column(name = "REF_ORDER_NO")
    @ApiParam(value = "关联单号")
    public String refOrderNo;
}
