package cn.estsh.i3plus.pojo.sweb.sqlpack;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.base.tool.SqlPack;
import cn.estsh.i3plus.pojo.sweb.bean.*;
import org.apache.commons.lang3.StringUtils;

/**
 * @Description : hql 封装
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-04-01 17:59
 * @Modify:
 **/
public class SwebHqlPack {

    /**
     * 通用封装isValid、isDeleted等参数
     *
     * @param bean
     * @param hqlStr
     * @return
     */
    private static String buildHql(BaseBean bean, StringBuffer hqlStr) {
        // 判断工厂代码是否为空
        if (StringUtils.isNotBlank(bean.getOrganizeCode())) {
            SqlPack.getStringEqualPack(bean.getOrganizeCode(), "organizeCode", hqlStr);
        }

        // 封装有效状态和删除状态
        Integer isValid = bean.getIsValid();
        //默认查有效数据
        if (isValid != null && isValid != 0) {
            SqlPack.getNumEqualPack(isValid, "isValid", hqlStr);
        } else {
            SqlPack.getNumEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue(), "isValid", hqlStr);
        }
        SqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", hqlStr);
        return hqlStr.toString();
    }

    public static String getPurchaseOrderWhereHql(SwebPurchaseOrder purchaseOrder) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(purchaseOrder.getOrderNo(), "orderNo", result);
        HqlPack.getStringEqualPack(purchaseOrder.getVendorCode(), "vendorCode", result);
        HqlPack.getNumEqualPack(purchaseOrder.getOrderStatus(), "orderStatus", result);
        return buildHql(purchaseOrder, result);
    }

    public static String getPackAgeWhereHql(SwebPackage swebPackage) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(swebPackage.getPackageNo(), "packageNo", result);
        HqlPack.getStringEqualPack(swebPackage.getParentPackageNo(), "parentPackageNo", result);
        HqlPack.getNumEqualPack(swebPackage.getPackTypeId(), "packTypeId", result);
        return buildHql(swebPackage, result);
    }

    public static String getProcurementPlanOrderWhereHql(SwebProcurementPlanOrder swebProcurementPlanOrder) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(swebProcurementPlanOrder.getVendorCode(), "vendorCode", result);
        HqlPack.getStringLikerPack(swebProcurementPlanOrder.getOrderNo(), "orderNo", result);
        return buildHql(swebProcurementPlanOrder, result);
    }

    public static String getProcurementPlanOrderDeatilsWhereHql(SwebProcurementPlanOrderDetails swebProcurementPlanOrderDetails) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(swebProcurementPlanOrderDetails.getOrderNo(), "orderNo", result);
        return buildHql(swebProcurementPlanOrderDetails, result);
    }

    public static String getVendorRelWhereHql(SwebVendorRel vendorRel) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(vendorRel.getVendorCode(), "vendorCode", result);
        HqlPack.getStringLikerPack(vendorRel.getPlannerCode(), "plannerCode", result);
        return buildHql(vendorRel, result);
    }

    /*public static String getPurchaseOrderDetailsWhereHql(SwebPurchaseOrderDetails swebPurchaseOrderDetails) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(swebPurchaseOrderDetails.getOrderNo(), "orderNo", result);
        return buildHql(swebPurchaseOrderDetails, result);
    }*/
}
