package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * @Description : PO订单明细信息
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-11-06 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "WMS_DOC_PO_DETAILS")
@Api("PO订单明细信息")
public class WmsPOMasterDetails extends BaseBean {
    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    public String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam("物料名称")
    public String partNameRdd;

    @Column(name = "ITEM")
    @ApiParam("行号")
    public Integer item;

    @Column(name = "QTY")
    @ColumnDefault("0")
    @ApiParam(value = "需求数量", example = "0")
    public Double qty;

    public Double getQty(){ return this.qty == null ? 0 : this.qty; }

    @Column(name = "UNIT")
    @ApiParam("单位")
    public String unit;

    @Column(name = "ORDER_NO")
    @ApiParam("订单号")
    public String orderNo;

    @Column(name = "PRINT_QTY")
    @ColumnDefault("0")
    @ApiParam(value = "条码打印数量", example = "0")
    public Double printQty;

    public Double getPrintQty(){ return this.printQty == null ? 0 : this.printQty; }

    @Column(name = "RC_QTY")
    @ColumnDefault("0")
    @ApiParam(value = "收货数量", example = "0")
    public Double rcQty;

    public Double getRcQty(){ return this.rcQty == null ? 0 : this.rcQty; }

    @Column(name = "PASS_QTY")
    @ColumnDefault("0")
    @ApiParam(value = "质检合格数量", example = "0")
    public Double passQty;

    public Double getPassQty(){ return this.passQty == null ? 0 : this.passQty; }

    @Column(name = "NG_QTY")
    @ColumnDefault("0")
    @ApiParam(value = "质检不合格数量", example = "0")
    public Double ngQty;

    public Double getNgQty(){ return this.ngQty == null ? 0 : this.ngQty; }

    @Column(name = "PLAN_DATE")
    @ApiParam("计划交货日期")
    public String planDate;

    @Column(name = "PLAN_TIME")
    @ApiParam("计划交货时间")
    public String planTime;

    @Column(name = "ERP_AREA_NO")
    @ApiParam("默认收货库存地")
    public String erpAreaNo;

    /**
     * 状态:10 N=正常,20 C=行取消
     */
    @Column(name = "ITEM_STATUS")
    @ApiParam("状态")
    public Integer itemStatus;

    @Column(name = "SNP")
    @ApiParam("标准包装")
    public String snp;

    /**
     * 是否免费:0=计费,1=免费
     */
    @Column(name = "IS_FREE")
    @ApiParam(value = "是否免费", example = "1")
    public Integer isFree;

    @Transient
    @ApiParam(value = "散件收货输入数量", example = "0")
    public Double inputRcQty;

    @Transient
    @ApiParam(value = "供应商批次")
    public String dateCode;

    @Transient
    @ApiParam("前端表格编辑使用")
    public Boolean isSet = false;

    @Transient
    @ApiParam("供应商批次字段是否可编辑")
    public Boolean isDateCodeEdit = true;

    public Double getInputRcQty(){ return this.inputRcQty == null ? 0 : this.inputRcQty; }
}
