package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Description : 作业任务生成日志
 * @Reference :
 * @Author : jack.lv
 * @CreateDate : 2019-03-18 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "WMS_TASK_CREATE_LOG")
@Api("作业任务生成日志表")
public class WmsTaskCreateLog extends BaseBean {

    @Column(name = "TASK_NO")
    @ApiParam("任务单号")
    public String taskNo;

    @Column(name = "DATA_SRC")
    @ApiParam("数据来源")
    public String dataSrc;

    @Column(name = "OP_TYPE_CODE")
    @ApiParam("作业类型")
    public String opTypeCode;

    @Column(name = "ERROR_MESSAGE")
    @ApiParam("错误信息")
    public String errorMessage;

    @Column(name = "TRANS_STATUS")
    @ApiParam("处理状态")
    public Integer transStatus;

    @Column(name = "REF_SRC")
    @ApiParam(value = "关联单号")
    private String refSrc;

    @Column(name = "CALL_CLASS")
    @ApiParam("实现类")
    public String callClass;

    @Column(name = "CALL_FUN")
    @ApiParam("实现类")
    public String callFun;

    @Column(name = "START_TIME")
    @ApiParam("开始执行时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    public Date startTime;

    @Column(name = "END_TIME")
    @ApiParam("结束执行时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    public Date endTime;

    @Column(name = "IN_PARAMS")
    @ApiParam(value = "输入参数")
    private String inParams;

    @Column(name = "OUT_PARAMS")
    @ApiParam(value = "输出参数")
    private String outParams;

    @Column(name = "OUT_RESULT")
    @ApiParam(value = "执行结果")
    private String outResult;
}
