package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * @Description : 作业任务表信息
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-11-06 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "WMS_TASK")
@Api("作业任务表")
public class WmsTaskInfo extends BaseBean {

    @Column(name = "ORDER_NO")
    @ApiParam("单号")
    public String orderNo;

    @Column(name = "MOVE_NO")
    @ApiParam("移动单号")
    public String moveNo;

    @Column(name = "USER_NO")
    @ApiParam("作业人员")
    public String userNo;

    @Column(name = "OP_TYPE_CODE")
    @ApiParam("作业类型")
    public String opTypeCode;

    @Column(name = "REMARK")
    @ApiParam("备注")
    public String remark;

    /**
     * 状态:1=创建,10=待处理,20=已处理
     */
    @Column(name = "TASK_STATUS")
    @ApiParam(value = "任务状态", example = "1")
    public Integer taskStatus;

    @Column(name = "TRANS_TYPE_CODE")
    @ApiParam("交易类型")
    public String transTypeCode;

    @Column(name = "PRE_USE_TIME")
    @ApiParam(value = "预计作业时间(分钟)", example = "1")
    public Integer preUseTime;

    @Column(name = "IS_ONE_STEP")
    @ApiParam("是否一步法操作")
    public Integer isOneStep;

    @ApiParam("作业类型名称")
    @Transient
    public String opTypeName;

    @ApiParam("作业任务明细")
    @Transient
    public List<WmsTaskDetails> taskDetailsList;

}
